diff --git a/web/migrations/versions/1586db67b98e_.py b/web/migrations/versions/1586db67b98e_.py
new file mode 100644
index 000000000..dfe043fab
--- /dev/null
+++ b/web/migrations/versions/1586db67b98e_.py
@@ -0,0 +1,38 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+"""Added server id for cloud deployment
+
+Revision ID: 1586db67b98e
+Revises: 15c88f765bc8
+Create Date: 2022-01-04 13:08:05.484598
+
+"""
+from pgadmin.model import db
+
+
+# revision identifiers, used by Alembic.
+revision = '1586db67b98e'
+down_revision = '15c88f765bc8'
+branch_labels = None
+depends_on = None
+
+
+def upgrade():
+    db.engine.execute(
+        'ALTER TABLE process ADD COLUMN server_id INTEGER DEFAULT 0'
+    )
+    db.engine.execute(
+        'ALTER TABLE server ADD COLUMN cloud_status INTEGER DEFAULT 0'
+    )
+
+
+def downgrade():
+    # pgAdmin only upgrades, downgrade not implemented.
+    pass
diff --git a/web/pgacloud/pgacloud.py b/web/pgacloud/pgacloud.py
new file mode 100755
index 000000000..a0a1c32ba
--- /dev/null
+++ b/web/pgacloud/pgacloud.py
@@ -0,0 +1,96 @@
+#!/usr/bin/env python3
+
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import argparse
+import os
+
+
+def load_providers():
+    """ Loads all the providers """
+    providers = {}
+
+    path = os.path.dirname(os.path.realpath(__file__))
+    modules = os.listdir(path + '/providers')
+
+    for filename in modules:
+        filename = path + '/providers/' + filename
+
+        if os.path.isfile(filename):
+            basename = os.path.basename(filename)
+            base, extension = os.path.splitext(basename)
+
+            if extension == ".py" and not basename.startswith("_"):
+                module = __import__("providers." + basename[:-3],
+                                    fromlist=["providers"])
+                provider = module.load()
+                providers[basename[:-3]] = provider
+
+    return providers
+
+
+def get_args(providers):
+    """ Creates the parsers and returns the args """
+    # Create the top-level parser
+    parser = argparse.ArgumentParser(prog='pgacloud.py')
+    parser.add_argument('--debug', action=argparse.BooleanOptionalAction,
+                        default=True, help='send debug messages to stderr')
+
+    # Create the provider sub-parser
+    parsers = parser.add_subparsers(help='provider help', dest='provider')
+
+    # Load the provider parsers
+    for provider in providers:
+        providers[provider].init_args(parsers)
+
+    args = parser.parse_args()
+
+    return parser, args
+
+
+def execute_command(providers, parser, args):
+    """ Executes the command in the provider """
+
+    # Switch - for _ in command names. We use - in the CLI syntax for ease of
+    # use, but we need an _ in Python function names
+    if 'command' in args and args.command is not None:
+        args.command = args.command.replace('-', '_')
+
+    # Figure out what provider the command was for (if any) and call the
+    # relevant function. If we don't get a match, print the help
+    if args.provider in providers and \
+            'command' in args and \
+            args.command is not None:
+        command = providers[args.provider].commands()[args.command]
+        command(args)
+    else:
+        # If no provider has been given, display the top level help,
+        # otherwise, call the help() method in the provider
+        if args.provider is None:
+            parser.print_help()
+        else:
+            command = providers[args.provider].commands()['help']
+            command()
+
+
+def main():
+    """ Entry point """
+    # Load the providers
+    providers = load_providers()
+
+    # Get the args
+    parser, args = get_args(providers)
+
+    # Execute the command
+    execute_command(providers, parser, args)
+
+
+if __name__ == '__main__':
+    main()
diff --git a/web/pgacloud/providers/_abstract.py b/web/pgacloud/providers/_abstract.py
new file mode 100644
index 000000000..9547104eb
--- /dev/null
+++ b/web/pgacloud/providers/_abstract.py
@@ -0,0 +1,31 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+class AbsProvider:
+    """ Abstract provider """
+    parser = None
+
+    def init_args(self, parsers):
+        """Not Required."""
+        pass
+
+    def commands(self):
+        """ Get the list of commands for the current provider. """
+        attrs = filter(lambda attr: attr.startswith('cmd_'), dir(self))
+        commands = {}
+
+        for attr in attrs:
+            method = getattr(self, attr)
+            commands[attr[4:]] = method
+
+        return commands
+
+    def cmd_help(self):
+        """ Prints the provider level help """
+        self.parser.print_help()
diff --git a/web/pgacloud/providers/rds.py b/web/pgacloud/providers/rds.py
new file mode 100644
index 000000000..3cd82de94
--- /dev/null
+++ b/web/pgacloud/providers/rds.py
@@ -0,0 +1,315 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+""" Amazon RDS PostgreSQL provider """
+
+import configparser
+import os
+import time
+import boto3
+
+from providers._abstract import AbsProvider
+from utils.io import debug, error, output
+from utils.misc import get_my_ip, get_random_id
+
+DEL_SEC_GROUP_MSG = 'Deleting security group: {}...'
+
+
+class RdsProvider(AbsProvider):
+    def __init__(self):
+        self._clients = {}
+        self._access_key = None
+        self._secret_key = None
+        self._session_token = None
+        self._database_pass = None
+        self._default_region = None
+
+        # Get the credentials
+        if 'AWS_ACCESS_KEY_ID' in os.environ:
+            self._access_key = os.environ['AWS_ACCESS_KEY_ID']
+
+        if 'AWS_SECRET_ACCESS_KEY' in os.environ:
+            self._secret_key = os.environ['AWS_SECRET_ACCESS_KEY']
+
+        if 'AWS_SESSION_TOKEN' in os.environ:
+            self._session_token = os.environ['AWS_SESSION_TOKEN']
+
+        if 'AWS_DATABASE_PASSWORD' in os.environ:
+            self._database_pass = os.environ['AWS_DATABASE_PASSWORD']
+
+    def init_args(self, parsers):
+        """ Create the command line parser for this provider """
+        self.parser = parsers.add_parser('rds',
+                                         help='Amazon AWS RDS PostgreSQL',
+                                         epilog='Credentials are read from '
+                                                '~/.aws/config by default and '
+                                                'can be overridden in the '
+                                                'AWS_ACCESS_KEY_ID and '
+                                                'AWS_SECRET_ACCESS_KEY '
+                                                'environment variables. '
+                                                'The default region is read '
+                                                'from ~/.aws/config and will '
+                                                'fall back to us-east-1 if '
+                                                'not present.')
+        self.parser.add_argument('--region', default=self._default_region,
+                                 help='name of the AWS region (default: {})'
+                                 .format(self._default_region))
+
+        # Create the command sub-parser
+        parsers = self.parser.add_subparsers(help='RDS commands',
+                                             dest='command')
+
+        # Create the create instance command parser
+        parser_create_instance = parsers.add_parser('create-instance',
+                                                    help='create a new '
+                                                         'instance')
+        parser_create_instance.add_argument('--name', required=True,
+                                            help='name of the instance')
+        parser_create_instance.add_argument('--db-name', default='postgres',
+                                            help='name of the default '
+                                                 'database '
+                                                 '(default: postgres)')
+        parser_create_instance.add_argument('--db-password', required=False,
+                                            help='password for the database')
+        parser_create_instance.add_argument('--db-username',
+                                            default='postgres',
+                                            help='user name for the database '
+                                                 '(default: postgres)')
+        parser_create_instance.add_argument('--db-port', type=int,
+                                            default=5432,
+                                            help='port of the database '
+                                                 '(default: 5432)')
+        parser_create_instance.add_argument('--db-version',
+                                            default='13.3',
+                                            help='version of PostgreSQL '
+                                                 'to deploy (default: 13.3)')
+        parser_create_instance.add_argument('--instance-type', required=True,
+                                            help='machine type for the '
+                                                 'instance nodes, e.g. '
+                                                 'db.m3.large')
+        parser_create_instance.add_argument('--storage-iops', type=int,
+                                            default=0,
+                                            help='storage IOPs to allocate '
+                                                 '(default: 0)')
+        parser_create_instance.add_argument('--storage-size', type=int,
+                                            required=True,
+                                            help='storage size in GB')
+        parser_create_instance.add_argument('--storage-type', default='gp2',
+                                            help='storage type for the data '
+                                                 'database (default: gp2)')
+        parser_create_instance.add_argument('--public-ip', default='127.0.0.1',
+                                            help='Public IP '
+                                                 '(default: 127.0.0.1)')
+
+        # Create the delete instance command parser
+        parser_delete_instance = parsers.add_parser('delete-instance',
+                                                    help='delete an instance')
+        parser_delete_instance.add_argument('--name', required=True,
+                                            help='name of the instance')
+        parser_delete_instance.add_argument('--security-group',
+                                            help='name of a security group to'
+                                                 'delete as well')
+
+    ##########################################################################
+    # AWS Helper functions
+    ##########################################################################
+    def _get_aws_client(self, type, args):
+        """ Create/cache/return an AWS client object """
+        if type in self._clients:
+            return self._clients[type]
+
+        session = boto3.Session(
+            aws_access_key_id=self._access_key,
+            aws_secret_access_key=self._secret_key
+        )
+
+        self._clients['type'] = session.client(type, region_name=args.region)
+
+        return self._clients['type']
+
+    def _create_security_group(self, args):
+        """ Create a new security group for the instance """
+        ec2 = self._get_aws_client('ec2', args)
+        ip = args.public_ip if args.public_ip else get_my_ip()
+
+        # Deploy the security group
+        try:
+            name = 'pgacloud_{}_{}_{}'.format(args.name,
+                                              ip.replace('.', '-'),
+                                              get_random_id())
+            debug(args, 'Creating security group: {}...'.format(name))
+            output({'Creating': 'Creating security group: {}...'.format(name)})
+            response = ec2.create_security_group(
+                Description='Inbound access for {} to RDS instance {}'.format(
+                    ip, args.name),
+                GroupName=name
+            )
+        except Exception as e:
+            error(args, str(e))
+
+        return response['GroupId']
+
+    def _add_ingress_rule(self, args, security_group):
+        """ Add a local -> PostgreSQL ingress rule to a security group """
+        ec2 = self._get_aws_client('ec2', args)
+        ip = args.public_ip if args.public_ip else '{}/32'.format(get_my_ip())
+        port = args.db_port or 5432
+
+        try:
+            output({'Adding': 'Adding ingress rule for: {}...'.format(ip)})
+            debug(args,
+                  'Adding ingress rule for: {}...'.format(ip))
+            ec2.authorize_security_group_ingress(
+                GroupId=security_group,
+                IpPermissions=[
+                    {
+                        'FromPort': port,
+                        'ToPort': port,
+                        'IpProtocol': 'tcp',
+                        'IpRanges': [
+                            {
+                                'CidrIp': ip,
+                                'Description': 'pgcloud client {}'.format(ip)
+                            },
+                        ]
+                    },
+                ]
+            )
+        except Exception as e:
+            error(args, e)
+
+    def _create_rds_instance(self, args, security_group):
+        """ Create an RDS instance """
+        ec2 = self._get_aws_client('ec2', args)
+        rds = self._get_aws_client('rds', args)
+
+        db_password = self._database_pass if self._database_pass is not None\
+            else args.db_password
+
+        try:
+            debug(args, 'Creating RDS instance: {}...'.format(args.name))
+            rds.create_db_instance(DBInstanceIdentifier=args.name,
+                                   AllocatedStorage=args.storage_size,
+                                   DBName=args.db_name,
+                                   Engine='postgres',
+                                   Port=args.db_port,
+                                   EngineVersion=args.db_version,
+                                   StorageType=args.storage_type,
+                                   StorageEncrypted=True,
+                                   Iops=args.storage_iops,
+                                   AutoMinorVersionUpgrade=True,
+                                   MultiAZ=False,
+                                   MasterUsername=args.db_username,
+                                   MasterUserPassword=db_password,
+                                   DBInstanceClass=args.instance_type,
+                                   VpcSecurityGroupIds=[
+                                       security_group,
+                                   ])
+
+        except rds.exceptions.DBInstanceAlreadyExistsFault as e:
+            try:
+                debug(args, DEL_SEC_GROUP_MSG.format(security_group))
+                ec2.delete_security_group(GroupId=security_group)
+            except Exception:
+                pass
+            error(args, 'RDS instance {} already exists.'.format(args.name))
+        except Exception as e:
+            try:
+                debug(args, DEL_SEC_GROUP_MSG.format(security_group))
+                ec2.delete_security_group(GroupId=security_group)
+            except Exception:
+                pass
+            error(args, str(e))
+
+        # Wait for completion
+        running = True
+        while running:
+            response = rds.describe_db_instances(
+                DBInstanceIdentifier=args.name)
+
+            db_instance = response['DBInstances'][0]
+            status = db_instance['DBInstanceStatus']
+
+            if status != 'creating' and status != 'backing-up':
+                running = False
+
+            if running:
+                time.sleep(5)
+
+        return response['DBInstances']
+
+    def _delete_rds_instance(self, args, name):
+        """ Delete an RDS instance """
+        rds = self._get_aws_client('rds', args)
+
+        debug(args, 'Deleting RDS instance: {}...'.format(name))
+        try:
+            rds.delete_db_instance(
+                DBInstanceIdentifier=name,
+                SkipFinalSnapshot=True,
+                DeleteAutomatedBackups=True
+            )
+        except Exception as e:
+            error(args, str(e))
+
+        # Wait for completion
+        while True:
+            try:
+                rds.describe_db_instances(DBInstanceIdentifier=args.name)
+            except rds.exceptions.DBInstanceNotFoundFault:
+                return
+            except Exception as e:
+                error(args, str(e))
+
+            time.sleep(5)
+
+    def _delete_security_group(self, args, id):
+        """ Delete a security group """
+        ec2 = self._get_aws_client('ec2', args)
+
+        debug(args, 'Deleting security group: {}...'.format(id))
+        try:
+            ec2.delete_security_group(
+                GroupId=id
+            )
+        except Exception as e:
+            error(args, str(e))
+
+    ##########################################################################
+    # User commands
+    ##########################################################################
+    def cmd_create_instance(self, args):
+        """ Create an RDS instance and security group """
+        security_group = self._create_security_group(args)
+        self._add_ingress_rule(args, security_group)
+        instance = self._create_rds_instance(args, security_group)
+
+        data = {'instance': {
+            'Id': instance[0]['DBInstanceIdentifier'],
+            'Location': instance[0]['AvailabilityZone'],
+            'SecurityGroupId': security_group,
+            'Hostname': instance[0]['Endpoint']['Address'],
+            'Port': instance[0]['Endpoint']['Port'],
+            'Database': instance[0]['DBName'],
+            'Username': instance[0]['MasterUsername']
+        }}
+
+        output(data)
+
+    def cmd_delete_instance(self, args):
+        """ Delete an RDS instance and (optionally) a security group """
+        self._delete_rds_instance(args, args.name)
+
+        if args.security_group is not None:
+            self._delete_security_group(args, args.security_group)
+
+
+def load():
+    """ Loads the current provider """
+    return RdsProvider()
diff --git a/web/pgacloud/utils/io.py b/web/pgacloud/utils/io.py
new file mode 100644
index 000000000..e55834702
--- /dev/null
+++ b/web/pgacloud/utils/io.py
@@ -0,0 +1,38 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import datetime
+import json
+import sys
+import time
+
+
+def debug(args, message):
+    """ Print a debug message """
+    if not args.debug:
+        return
+
+    now = datetime.datetime.now()
+
+    print('[{}]: {}'.format(now.strftime("%H:%M:%S"), message),
+          file=sys.stderr, flush=True)
+
+
+def error(args, message):
+    """ Print an error message and exit """
+    debug(args, message)
+
+    output({'error': message})
+
+    sys.exit(1)
+
+
+def output(data):
+    """ Dump JSON output from a dict """
+    print(json.dumps(data), flush=True)
diff --git a/web/pgacloud/utils/misc.py b/web/pgacloud/utils/misc.py
new file mode 100644
index 000000000..5d66f354c
--- /dev/null
+++ b/web/pgacloud/utils/misc.py
@@ -0,0 +1,34 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import random
+import string
+import urllib3
+
+
+def get_my_ip():
+    """ Return the public IP of this host """
+    http = urllib3.PoolManager()
+    try:
+        external_ip = http.request.urlopen(
+            'https://ident.me').read().decode('utf8')
+    except Exception:
+        try:
+            external_ip = http.request.urlopen(
+                'https://ifconfig.me/ip').read().decode('utf8')
+        except Exception:
+            external_ip = '127.0.0.1'
+
+    return external_ip
+
+
+def get_random_id():
+    """ Return a random 10 byte string """
+    letters = string.ascii_letters + string.digits
+    return(''.join(random.choice(letters) for _ in range(10)))
diff --git a/web/pgadmin/browser/__init__.py b/web/pgadmin/browser/__init__.py
index fbf094600..517232210 100644
--- a/web/pgadmin/browser/__init__.py
+++ b/web/pgadmin/browser/__init__.py
@@ -763,7 +763,7 @@ def index():
         mfa_enabled=is_mfa_enabled(),
         login_url=login_url,
         _=gettext,
-        auth_only_internal=auth_only_internal
+        auth_only_internal=auth_only_internal,
     ))
 
     # Set the language cookie after login, so next time the user will have that
diff --git a/web/pgadmin/browser/server_groups/servers/__init__.py b/web/pgadmin/browser/server_groups/servers/__init__.py
index 392c81ae8..509f6cf92 100644
--- a/web/pgadmin/browser/server_groups/servers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/__init__.py
@@ -112,6 +112,10 @@ def server_icon_and_background(is_connected, manager, server):
         return 'icon-shared-server-not-connected{0}'.format(
             server_background_color
         )
+    elif server.cloud_status == -1:
+        return 'icon-server-cloud-deploy{0}'.format(
+            server_background_color
+        )
     else:
         return 'icon-server-not-connected{0}'.format(
             server_background_color
@@ -256,7 +260,8 @@ class ServerModule(sg.ServerGroupPluginModule):
                 user_name=server.username,
                 shared=server.shared,
                 is_kerberos_conn=bool(server.kerberos_conn),
-                gss_authenticated=manager.gss_authenticated
+                gss_authenticated=manager.gss_authenticated,
+                cloud_status=server.cloud_status
             )
 
     @property
@@ -998,7 +1003,8 @@ class ServerNode(PGChildNodeView):
             'tunnel_authentication': tunnel_authentication,
             'kerberos_conn': bool(server.kerberos_conn),
             'gss_authenticated': manager.gss_authenticated,
-            'gss_encrypted': manager.gss_encrypted
+            'gss_encrypted': manager.gss_encrypted,
+            'cloud_status': server.cloud_status
         }
 
         return ajax_response(response)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
index 74d622c25..ee384f629 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
@@ -342,17 +342,17 @@ define('pgadmin.node.schema', [
         pgBrowser.add_menus([{
           name: 'create_schema_on_coll', node: 'coll-schema', module: this,
           applies: ['object', 'context'], callback: 'show_obj_properties',
-          category: 'create', priority: 4, label: gettext('Schema...'),
+          category: 'create', priority: 1, label: gettext('Schema...'),
           icon: 'wcTabIcon icon-schema', data: {action: 'create'},
         },{
           name: 'create_schema', node: 'schema', module: this,
           applies: ['object', 'context'], callback: 'show_obj_properties',
-          category: 'create', priority: 4, label: gettext('Schema...'),
+          category: 'create', priority: 1, label: gettext('Schema...'),
           icon: 'wcTabIcon icon-schema', data: {action: 'create'},
         },{
           name: 'create_schema', node: 'database', module: this,
           applies: ['object', 'context'], callback: 'show_obj_properties',
-          category: 'create', priority: 4, label: gettext('Schema...'),
+          category: 'create', priority: 1, label: gettext('Schema...'),
           icon: 'wcTabIcon icon-schema', data: {action: 'create'},
           enable: 'can_create_schema',
         },
diff --git a/web/pgadmin/browser/server_groups/servers/static/js/server.js b/web/pgadmin/browser/server_groups/servers/static/js/server.js
index 2c6ccebf2..a48804809 100644
--- a/web/pgadmin/browser/server_groups/servers/static/js/server.js
+++ b/web/pgadmin/browser/server_groups/servers/static/js/server.js
@@ -80,13 +80,15 @@ define('pgadmin.node.server', [
         pgBrowser.add_menus([{
           name: 'create_server_on_sg', node: 'server_group', module: this,
           applies: ['object', 'context'], callback: 'show_obj_properties',
-          category: 'create', priority: 1, label: gettext('Server...'),
-          data: {action: 'create'}, icon: 'wcTabIcon icon-server', enable: 'canCreate',
+          category: 'register', priority: 1, label: gettext('Server...'),
+          data: {action: 'create'}, icon: 'wcTabIcon icon-server',
+          enable: 'canCreate',
         },{
           name: 'create_server', node: 'server', module: this,
           applies: ['object', 'context'], callback: 'show_obj_properties',
-          category: 'create', priority: 3, label: gettext('Server...'),
-          data: {action: 'create'}, icon: 'wcTabIcon icon-server', enable: 'canCreate',
+          category: 'register', priority: 3, label: gettext('Server...'),
+          data: {action: 'create'}, icon: 'wcTabIcon icon-server',
+          enable: 'canCreate',
         },{
           name: 'connect_server', node: 'server', module: this,
           applies: ['object', 'context'], callback: 'connect_server',
@@ -808,8 +810,8 @@ define('pgadmin.node.server', [
       // Fetch the updated data
       $.get(server_url)
         .done(function(res) {
-          if (res.shared && _.isNull(res.username) && data.user_id != current_user.id){
-            if (!res.service){
+          if (res.shared && _.isNull(res.username) && data.user_id != current_user.id) {
+            if (!res.service) {
               pgAdmin.Browser.Node.callbacks.show_obj_properties.call(
                 pgAdmin.Browser.Nodes[tree.itemData(item)._type], {action: 'edit'}
               );
@@ -818,13 +820,30 @@ define('pgadmin.node.server', [
               tree.setInode(item);
               tree.addIcon(item, {icon: 'icon-shared-server-not-connected'});
               Notify.info('Please enter the server details to connect to the server. This server is a shared server.');
-            }else{
+            } else {
               data.is_connecting = false;
               tree.unload(item);
               tree.setInode(item);
               tree.addIcon(item, {icon: 'icon-shared-server-not-connected'});
             }
           }
+          else if (res.cloud_status == -1) {
+            $.ajax({
+              type: 'GET',
+              timeout: 30000,
+              url: url_for('cloud.update_cloud_process', {'sid': res.id}),
+              cache: false,
+              async: true,
+              contentType: 'application/json',
+            })
+              .done(function() {
+                pgAdmin.Browser.BackgroundProcessObsorver.update_process_list();
+              })
+              .fail(function() {
+                console.warn(arguments);
+              });
+          }
+          return;
         }).always(function(){
           data.is_connecting = false;
         });
@@ -1033,7 +1052,7 @@ define('pgadmin.node.server', [
       };
 
       /* Wait till the existing request completes */
-      if(data.is_connecting) {
+      if(data.is_connecting || data.cloud_status == -1) {
         return;
       }
       data.is_connecting = true;
diff --git a/web/pgadmin/browser/static/js/browser.js b/web/pgadmin/browser/static/js/browser.js
index 7cb3e7002..4794effed 100644
--- a/web/pgadmin/browser/static/js/browser.js
+++ b/web/pgadmin/browser/static/js/browser.js
@@ -326,9 +326,18 @@ define('pgadmin.browser', [
     },
     menu_categories: {
       /* name, label (pair) */
+      'register': {
+        label: gettext('Register'),
+        priority: 1,
+        /* separator above this menu */
+        above: false,
+        below: true,
+        /* icon: 'fa fa-magic', */
+        single: true,
+      },
       'create': {
         label: gettext('Create'),
-        priority: 1,
+        priority: 2,
         /* separator above this menu */
         above: false,
         below: true,
diff --git a/web/pgadmin/browser/static/js/collection.js b/web/pgadmin/browser/static/js/collection.js
index 66151dddf..9f944ff19 100644
--- a/web/pgadmin/browser/static/js/collection.js
+++ b/web/pgadmin/browser/static/js/collection.js
@@ -46,7 +46,7 @@ define([
         pgAdmin.Browser.add_menus([{
           name: 'refresh', node: this.type, module: this,
           applies: ['object', 'context'], callback: 'refresh',
-          priority: 1, label: gettext('Refresh'),
+          priority: 2, label: gettext('Refresh'),
           icon: 'fa fa-sync-alt',
         }]);
 
diff --git a/web/pgadmin/browser/static/js/node.js b/web/pgadmin/browser/static/js/node.js
index 05e3c669c..9e6d3d543 100644
--- a/web/pgadmin/browser/static/js/node.js
+++ b/web/pgadmin/browser/static/js/node.js
@@ -118,8 +118,8 @@ define('pgadmin.browser.node', [
         module: self,
         applies: ['object', 'context'],
         callback: 'refresh',
-        priority: 1,
-        label: gettext('Refresh'),
+        priority: 2,
+        label: gettext('Refresh...'),
         icon: 'fa fa-sync-alt',
       }]);
 
@@ -792,6 +792,9 @@ define('pgadmin.browser.node', [
           }
 
           l = gettext('Create - %s', this.label);
+          if (this.type == 'server') {
+            l = gettext('Register - %s', this.label);
+          }
           p = addPanel();
 
           setTimeout(function() {
